/* 
 * Copyright (c) 2000  Takuya SHIOZAKI
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL TAKUYA SHIOZAKI BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 * 
 * Except as contained in this notice, the name of Takuya SHIOZAKI shall
 * not be used in advertising or otherwise to promote the sale, use or
 * other dealings in this Software without prior written authorization
 * from Takuya SHIOZAKI.
 *
 * $Id: CharClockP.h,v 1.8 2000/12/11 17:36:01 tshiozak Exp $
 *
 */

#ifndef _CharClockP_h
#define _CharClockP_h

#include <time.h>

#include <CharClock/CharClock.h>
#include <X11/Xaw/SimpleP.h>


typedef struct _CharClockPart {
    /* resource fields */
    Pixel fore;
    String about;
    String time1, time2;
    String am, pm;
    String date1, date2;
    String title1, title2;
    union {
        String a[7];
        struct {
            String sun, mon, tue, wed, thu, fri, sat;
        } n;
    } week;
    int ep_x, ep_y;
    int ep_closed_time, ep_interval_min, ep_interval_max, time_period;
    int h_top_x, h_top_y;
    int er_width, er_height;
    int ms_x_plus, ms_y_plus;
    int fukidashi_x, fukidashi_y;
    int fukidashi_width, fukidashi_height;
    int force_font_extent_y;
    XFontSet fontset;
    /* private datas */
    struct {
        GC gc;
        struct _bitmap {
            String file;
            Pixmap pixmap; /* full depth */
            unsigned int width, height;
        } bitmap1, ep_bitmap1, ep_bitmap2;
        Pixmap about_pixmap;
        XtIntervalId interval_id;
        enum { EyeOpen, EyeClose } eye_state;
        enum { PopTime, PopDate } pop_state;
        int eyetimer_remain;
        time_t time_prev;
        struct {
            Widget popup, dialog;
        } about;
    } p;
} CharClockPart;

typedef struct _CharClockRec {
    CorePart core;
    SimplePart simple;
    CharClockPart charclock;
} CharClockRec;

typedef struct _CharClockClassPart {
    int dummy;
} CharClockClassPart;

typedef struct _CharClockClassRec {
    CoreClassPart core_class;
    SimpleClassPart simple_class;
    CharClockClassPart charclock_class;
} CharClockClassRec;

extern CharClockClassRec charClockClassRec;


#endif

/* end of file */
