/* 
 * Copyright (c) 2000  Takuya SHIOZAKI
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL TAKUYA SHIOZAKI BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 * 
 * Except as contained in this notice, the name of Takuya SHIOZAKI shall
 * not be used in advertising or otherwise to promote the sale, use or
 * other dealings in this Software without prior written authorization
 * from Takuya SHIOZAKI.
 *
 * $Id: xccda.c,v 1.6 2000/12/11 17:36:01 tshiozak Exp $
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xatom.h>
#include <CharClock/CharClock.h>

static Atom wm_delete_window;

static void
Quit(Widget w, XEvent *ev, String *params, Cardinal *nparams)
{
    if (ev->type!=ClientMessage || ev->xclient.data.l[0] == wm_delete_window) {
        XCloseDisplay(XtDisplay(w));
        exit(0);
    }
}

static XtActionsRec actions[] = {
    { "quit", Quit },
};

static XrmOptionDescRec options[] = {
    { "-fg", "*Foreground", XrmoptionSepArg, NULL },
};

static String fallbacks[] = {
    "*translations: #override\\n<Message>WM_PROTOCOLS: quit()\\n"
    "<Key>q: quit()\\n\n",
    NULL
};


int
main(int ac, char **av)
{
    XtAppContext app_context;
    Widget toplevel, clock;
    String appclass, dup_av0;

    XtSetLanguageProc(NULL, NULL, NULL);

    dup_av0 = strdup(av[0]);
    if ((appclass=strrchr(dup_av0, '/')))
        appclass++;
    else
        appclass = dup_av0;
    *appclass = toupper(*appclass);
    toplevel = XtVaOpenApplication(&app_context, appclass,
                                   options, XtNumber(options),
                                   &ac, av, fallbacks,
                                   applicationShellWidgetClass,
                                   NULL);
    XtAppAddActions(app_context, actions, XtNumber(actions));
    clock =
        XtVaCreateManagedWidget(
            "clock", charClockWidgetClass, toplevel,
            NULL);
    XtRealizeWidget(toplevel);
    wm_delete_window =
        XInternAtom(XtDisplay(toplevel), "WM_DELETE_WINDOW", False);
    XSetWMProtocols(XtDisplay(toplevel), XtWindow(toplevel),
                    &wm_delete_window, 1);
    XtAppMainLoop(app_context);

    return 0;
}
